#pragma once

#include "common.h"
#include "SyntaxError.h"
#include "Logger.h"

struct Loop {
    vector<vector<Token>> instructions;
    vector<Token> condition;
};

class Interpreter {
private:
    int skipScope = 0;
    int repeatScope = 0;
    vector<Loop> loops;        
    vector<Token> currentInstructionForWhileLoop;
    int whileLoopStartIndex;
    SyntaxError syntaxError;
    vector<Token> tokens;
    map<string, Value> variables;
    Logger log;
    int tokenIndex = -1;
    optional<Token> consume();
    optional<Token> peek(int offset = 1);

public:
    void convertToTokens(vector<Token> tokenList);
    void executeCode(vector<Token> tokens);
};
